package cn.com.qmth.examcloud.core.basic.service.impl;

import cn.com.qmth.examcloud.api.commons.security.bean.User;
import cn.com.qmth.examcloud.commons.util.UUID;
import cn.com.qmth.examcloud.core.basic.base.util.VerifyCode;
import cn.com.qmth.examcloud.core.basic.service.VerifyCodeService;
import cn.com.qmth.examcloud.core.basic.service.bean.VerifyCodeLoginInfo;
import org.apache.commons.codec.binary.Base64;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

/**
 * 验证码相关接口
 */
@Service
public class VerifyCodeServiceImpl implements VerifyCodeService {

    private static final Logger log = LoggerFactory.getLogger(VerifyCodeServiceImpl.class);

    /**
     * 验证码生成接口
     *
     * @return 字符串：base64 + uuid
     */
    @Override
    public String verifyCodeGenerate(Long rootOrgId, String accountValue) {
        VerifyCode.Result result = VerifyCode.generateVerifyCode();
        log.info(String.format("accountValue = %s, generateVerifyCode = %s", accountValue, result.getResult()));

        byte[] bytes = VerifyCode.imageToBytes(result.getImage());
        String base64 = Base64.encodeBase64String(bytes);

        //todo

        return base64 + "#" + UUID.randomUUID();
    }

    /**
     * 验证码登录接口
     *
     * @return 登录成功信息
     */
    @Override
    public User verifyCodeLogin(VerifyCodeLoginInfo info) {

        System.out.println(info.getVerifyCode());
        //todo

        return null;
    }

    /**
     * Resource接口
     */
    @Override
    public void verifyCodeResource(String uuid) {
        System.out.println(uuid);
        //todo
    }

}
